unit AboutSystem;
{
  "    
    win95/98"

  :  ..
  : 2.0  15.11.00

     - 13_vlad@mail.ru

  www.vladimir13.narod.ru
  www.vladimir13.by.ru
   ,  
         !!!

     CPU  :
  CPU Speed 1.0, Copyright (c) 1998 Erik Salaj, erik@dodo.sk
  }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type

//-------  - AboutBox
  TAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;


  //   
  TSystem_info=class(tpersistent)
  private
    //  
    fProcVendor: string;
    // 
    fProcLevel:string;
    // - 
    fProcNum:string;
    //  BIOS
    fBiosVer:string;
    //  
    fProcSpeed:string;
  public
    constructor create;
  published
    //  
    property ProcVendor:string read fProcVendor write fProcVendor;
    // 
    property ProcLevel:string read fProcLevel write fProcLevel;
    // - 
    property ProcNum:string read fProcNum write fProcNum;
    //  BIOS
    property BiosVer:string read fBiosVer write fbiosver;
    //  
    property ProcSpeed:string read fProcSpeed write fProcSpeed;
  end;

  //   
  TMemory_info=class(tpersistent)
  private
    //  % 
    fMemUse:string;
    //   
    fMemPhysTotal:string;
    //   
    fMemPhysFree:string;
    //   
    fMemVirtTotal:string;
    //   
    fMemVirtFree:string;

    function GetMemPhysFree: string;
    function GetMemUse: string;
    function GetMemVirtFree: string;
  public
    constructor create;
  published
    //  
    property MemUse:string read GetMemUse write fMemUse;
    //   
    property MemPhysTotal:string read fMemPhysTotal write fMemPhysTotal;
    //   
    property MemPhysFree:string read GetMemPhysFree write fMemPhysFree;
    //   
    property MemVirtTotal:string read fMemVirtTotal write fMemVirtTotal;
    //   
    property MemVirtFree:string read GetMemVirtFree write fMemVirtFree;

    end;


  TPrinter_info=class(tpersistent)
  private
    //   
    fDefaul_Printer: string;
    //   
    fPrinters:TStrings;
    function GetDefaul_Printer: string;
    function GetPrinters: TStrings;
    procedure SetPrinters(const Value: TStrings);
  public
    constructor create;
    destructor destroy;
  published
    //  
    property Defaul_Printer:string read GetDefaul_Printer write fDefaul_Printer;
    //   
    property Printers:TStrings read GetPrinters write SetPrinters;

    end;

  TDir_info=class(tpersistent)
  private
    //  windows
    fWinDir:string;
    //  
    fSysDir:string;
    //  
    fCurDir:string;
    //   
    fCacheDir:string;
    //   
    fDesktopDir:string;
    //  
    fFavoritesDir:string;
    //  
    fFontsDir:string;
    //  " "
    fPersonalDir:string;
    //  
    fProgramsDir:string;
    //  " "
    fSendToDir:string;
    //   
    fStartMenuDir:string;
    //  
    fStartUpDir:string;

    function GetCurDir: string;
  public
    constructor create;
  published  
    //  windows
    property DirWin:string read fWinDir write fWinDir;
    //  
    property DirSys:string read fSysDir write fSysDir;
    //  
    property DirCur:string read GetCurDir write fCurDir;
    property DirCache:string read fCacheDir write fCacheDir;
    property DirDesktop:string read fDesktopDir write fDesktopDir;
    property DirFavorites:string read fFavoritesDir write fFavoritesDir;
    property DirFonts:string read fFontsDir write fFontsDir;
    property DirPersonal:string read fPersonalDir write fPersonalDir;
    property DirPrograms:string read fProgramsDir write fProgramsDir;
    property DirSendTo:string read fSendToDir write fSendToDir;
    property DirStartMenu:string read fStartMenuDir write fStartMenuDir;
    property DirStartUp:string read fStartUpDir write fStartUpDir;
   end;

  TOS_info=class(tpersistent)
  private
    // 
    fPlatform: String;
    //  
    fOSVer: String;
    //
    fBuild: String;
    //  
    fAbout_Dir:tDir_Info;

  public
    constructor create;
    destructor destroy;
    //   Path   'e:\3333\666\...\66', NumChar- 
    function FormatPath(Path:string;NumChar:byte):string;
  published
    // 
    property Platform:String read fPlatform write fPlatform;
    //  
    property OSVer:String read fOSVer write fOSVer;
    //
    property Build: String read fBuild write fBuild;
    //  
    property About_Dir:tDir_Info read fAbout_Dir;
   end;


  TAboutSystem = class(TComponent)
  private
    // -  
    FAbout: TAbouTProperty;
     //  
    FAbout_System:TSystem_info;
    //  
    FAbout_Memory:tMemory_info;
    //  
    fAbout_Printer:tPrinter_info;
    //  
    fAbout_OS:tOS_Info;
  public
   constructor create(aOwner:tComponent);override;
   destructor destroy;override;
  published
   //  
   property About: TAbouTProperty read FAbout;
    //  
   property About_System:TSystem_info read FAbout_System;
    //  
   property About_Memory:tMemory_info read FABout_Memory;
    //  
   property About_Printer:tPrinter_info read fAbout_Printer;
   //  
   property About_OS:tOS_Info read fAbout_Os;

  end;

procedure Register;

implementation
{$R *.res}
uses  registry,printers;

procedure Register;
begin
  RegisterComponents('COM', [TAboutSystem]);

  RegisterPropertyEditor(TypeInfo(TAboutProperty),
      TAboutSystem, 'ABOUT', TAbouTProperty);
end;

{ TSystem_info }

constructor TSystem_info.create;
const
  DelayTime = 500;
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
  Speed:Double;
  SI: windows.TSystemInfo;
  s1:tstringlist;
  i:integer;
  R:TRegistry;
begin
  inherited;
  GetSystemInfo(SI);
  fProcNum:=IntToStr(Si.dwNumberOfProcessors);
  R:=TRegistry.Create;
  with R do
    begin
     RootKey:=HKEY_LOCAL_MACHINE;
     OpenKey('\Hardware\Description\System\CentralProcessor\0',false);
     fProcLevel:=ReadString('Identifier');
     fProcVendor:=ReadString('VendorIdentifier');
     OpenKey('\Enum\Root\',false);
     if HasSubKeys then
       begin
        S1:=TStringList.Create;
        GetKeyNames(S1);
        for i:=0 to S1.Count-1 do
          begin
           OpenKey('\Enum\root\'+s1[i]+'\0000\',false);
           if ReadString('BIOSVersion')<>'' then fBiosVer:=ReadString('BIOSVersion');
          end;
        S1.free;
       end;
     R.Free;
      case Si.wProcessorLevel of
        3: fProcLevel:=fProcLevel+' (80386)';
        4: fProcLevel:=fProcLevel+' (80486)';
        5: fProcLevel:=fProcLevel+' (Pentium)';
        6: fProcLevel:=fProcLevel+' (Pentium Pro)';
      end;
  end;

  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);

  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);

  Sleep(10);
  asm
    dw 310Fh
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;

  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);

  Speed := TimerLo / (1000.0 * DelayTime);
  fProcSpeed:= Format('%f MHz', [Speed])
end;



{ TTAboutSystem }

constructor TAboutSystem.create(aOwner: tComponent);
begin
  inherited;
  //  --
  FAbout_System:=TSystem_info.Create;
  FABout_Memory:=TMemory_info.Create;
  fAbout_Printer:=TPrinter_info.Create;
  fAbout_OS:=TOS_info.create;
end;

destructor TAboutSystem.destroy;
begin
  FAbout_System.Free;
  FABout_Memory.Free;
  fAbout_Printer.free;
  fAbout_OS.Free;
  inherited;
end;

{ TMemory_info }

constructor TMemory_info.create;
var
  MS: TMemoryStatus;
begin
  inherited;
  MS.dwLength := SizeOf(MS);
  GlobalMemoryStatus(MS);
    fMemUse:=inttostr(MS.dwMemoryLoad)+'%';
    fMemPhysTotal:=inttostr(MS.dwTotalPhys  div 1024)+' kb';
    fMemPhysFree:=inttostr(MS.dwAvailPhys div 1024)+' kb';
    fMemVirtTotal:=inttostr(MS.dwTotalVirtual div 1024)+' kb';
    fMemVirtFree:=inttostr(MS.dwAvailVirtual div 1024)+' kb';
end;

function TMemory_info.GetMemPhysFree: string;
var
  MS: TMemoryStatus;
begin
  MS.dwLength := SizeOf(MS);
  GlobalMemoryStatus(MS);
  fMemPhysFree:=inttostr(MS.dwAvailPhys div 1024)+' kb';
  Result := fMemPhysFree;
end;

function TMemory_info.GetMemUse: string;
var
  MS: TMemoryStatus;
begin
  MS.dwLength := SizeOf(MS);
  GlobalMemoryStatus(MS);
  fMemUse:=inttostr(MS.dwMemoryLoad)+'%';
  Result := fMemUse;
end;

function TMemory_info.GetMemVirtFree: string;
var
  MS: TMemoryStatus;
begin
  MS.dwLength := SizeOf(MS);
  GlobalMemoryStatus(MS);
  fMemVirtFree:=inttostr(MS.dwAvailVirtual div 1024)+' kb';
  Result := fMemVirtFree;
end;

{ TPrinter_info }

constructor TPrinter_info.create;
begin
 inherited;
 fPrinters:=TStringList.Create;
end;

destructor TPrinter_info.destroy;
begin
 fPrinters.Free;
 inherited;
end;

function TPrinter_info.GetDefaul_Printer: string;
begin
  if Printer.Printers.Count>0 then
      fDefaul_Printer:=Printer.Printers[Printer.PrinterIndex]
      else fDefaul_Printer:='.';
  Result := fDefaul_Printer;
end;

function TPrinter_info.GetPrinters: TStrings;
begin
fPrinters.Clear;
if Printer.Printers.Count>0 then
      fPrinters.Assign(Printer.Printers);
Result := fPrinters;
end;

procedure TPrinter_info.SetPrinters(const Value: TStrings);
begin
if Value is TStrings then fPrinters.Assign(value);
end;

{ TOS_info }

constructor TOS_info.create;
var
  VI: TOSVersionInfo;
begin
inherited;
fAbout_Dir:=TDir_info.create;
  VI.dwOSVersionInfoSize := SizeOf(VI);
  GetVersionEx(VI);
    case VI.dwPlatformID of
      VER_PLATFORM_WIN32S:fPlatform:='Windows 3.1x running Win32s';
      VER_PLATFORM_WIN32_WINDOWS:fPlatform:='Windows 95/98';
      VER_PLATFORM_WIN32_NT:fPlatform:='Windows NT';
    end;
  fOSVer:=Format('%d.%d', [VI.dwMajorVersion, VI.dwMinorVersion]);
  fBuild:=Format('%d', [LoWord(VI.dwBuildNumber)]);

end;

//   Path   'e:\3333\666\...\66', NumChar- 
destructor TOS_info.destroy;
begin
 fAbout_Dir.Free
end;

function TOS_info.FormatPath(Path: string; NumChar: byte): string;
var i:integer;
     s:shortstring;
begin
  if not (length(Path)>NumChar) then
     begin
       result:=Path;
       exit;
     end;

  for i:=Length(Path)-1 downto 1 do
    if Path[i]='\' then begin
                     s:='...'+copy(Path,i,Length(Path)-i+1);
                     break;
                     end;

  for i:=NumChar-Length(s) downto 1 do
    if Path[i]='\' then begin
                     break;
                     end;
    Result:=copy(Path,1,i)+s;
end;


constructor TDir_info.create;
var
  S: array[0..MAX_PATH] of char;
  R:TRegistry;
begin
 { Get Windows directory }
  GetWindowsDirectory(S, SizeOf(S));
  fWinDir:=s;
  { Get Windows system directory }
  GetSystemDirectory(S, SizeOf(S));
  fSysDir:=s;
  { Get Current directory for current process }
  GetCurrentDirectory(SizeOf(S), S);
  fCurDir:=s;
R := TRegistry.Create;
try
 R.RootKey := HKey_Current_User;
 R.OpenKey('Software\Microsoft\Windows\'+
  'CurrentVersion\Explorer\Shell Folders', False);
  fStartUpDir := R.ReadString('StartUp');
  fCacheDir := R.ReadString('Cache');
  fDesktopDir := R.ReadString('Desktop');
  fFavoritesDir := R.ReadString('Favorites');
  fFontsDir := R.ReadString('Fonts');
  fPersonalDir := R.ReadString('Personal');
  fProgramsDir := R.ReadString('Programs');
  fSendToDir := R.ReadString('SendTo');
  fStartMenuDir := R.ReadString('Start Menu');
finally
 R.Free;
end;

end;

function TDir_info.GetCurDir: string;
var
  S: array[0..MAX_PATH] of char;
begin
 { Get Current directory for current process }
  GetCurrentDirectory(SizeOf(S), S);
  fCurDir:=s;
 Result := fCurDir;
end;

{ TAbouProperty }

procedure TAboutProperty.Edit;
var
	msg: string;
const
	carriage_return = chr(13);
begin
  inherited;
	msg := '          tAboutSystem Component v2.0';
  AppendStr(msg, carriage_return);  AppendStr(msg, carriage_return);
  AppendStr(msg,'       2000 13 SoftWare ( ..)');
  AppendStr(msg, carriage_return);
  AppendStr(msg, carriage_return);
  AppendStr(msg,'       e-mail:');
  AppendStr(msg, carriage_return);
  AppendStr(msg, carriage_return);
  AppendStr(msg,'                  13_vlad@mail.ru');
  AppendStr(msg, carriage_return);
  AppendStr(msg, carriage_return);
  AppendStr(msg,'            :');
  AppendStr(msg, carriage_return);
  AppendStr(msg, carriage_return);
  AppendStr(msg,'   "  " - www.vladimir13.narod.ru');
  AppendStr(msg, carriage_return);  AppendStr(msg, carriage_return);
  ShowMessage(msg);
end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
    	Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
 	Result := 'About...';
end;

end.
